alias -l dmdx return $scriptdirdialog.mdx    
alias -l vmdx return $scriptdirviews.mdx 
alias -l bmdx return $scriptdirbars.mdx 
alias -l gmdx return $scriptdirctl_gen.mdx 
alias -l udll return $+(",$scriptdir,mdx.dll,")
alias -l imgdir return $scriptdirImg\
alias -l mdx {
  if  ($isid)  dll $udll $1-
  elseif ( $2- == $null ) return $dll($udll,$1,.)
  return $dll($udll,$1,$2-)
}
menu status {
  Example
  .colors:rcolors
  .control panel:cpanel
  .friendnotes: dialog -m friendnotes friendnotes
}

alias rcolors  dialog -m colors colors
dialog colors {
  title "First example"
  size 291 189 222 180
  box "", 1, 5 3 210 140
  combo 20, 95 22 104 285, edit 
  combo 21, 95 52 104 285, edit 
  combo 22, 95 82 104 285, edit 
  combo 23, 95 112 104 285, edit 
  text "Background:", 5, 8 27 83 13, right
  text "Information:", 6, 8 57 83 13, right
  text "Lines:", 10, 8 87 83 13, right
  text "Text:", 11, 8 117 83 13, right
  button "OK", 200, 81 150 56 20, ok
}
on *:dialog:colors:init:0:{
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 20,21,22,23 ComboBoxEx drop > $vmdx
  did -i $dname 20,21,22,23 1 iconsize small
  var %tmp = 0 | while %tmp < 16 { did -i $dname 20,21,22,23 1 SetIcon 0 %tmp $+ , $+ $+($imgdir,colors.icl) | inc %tmp }
  var %tmp = 20 | While (%tmp < 24) { cor.cb colors %tmp | inc %tmp }
  did -c $dname 20 $calc(%clbg + 2)
  did -c $dname 21 $calc(%clinfo + 2 )
  did -c colors 22 $calc(%clline + 2)
  did -c colors 23 $calc(%cltext + 2)
}
on *:dialog:colors:sclick:200:{
  Set %clbg $calc($did(20).sel - 2)
  Set %clinfo $calc($did(21).sel - 2)
  Set %clline $calc($did(22).sel - 2)
  Set %cltext $calc($did(23).sel - 2)
}
alias cor.cb {
  did -a $1 $2 1 1 White
  did -a $1 $2 2 2 2 0 Black
  did -a $1 $2 3 3 2 0 Darkblue
  did -a $1 $2 4 4 0 Darkgreen
  did -a $1 $2 5 5 2 0 Red
  did -a $1 $2 6 6 2 0 Brown
  did -a $1 $2 7 7 2 0 Purple
  did -a $1 $2 8 8 2 0 Orange
  did -a $1 $2 9 9 2 0 Yellow
  did -a $1 $2 10 10 2 0 Lightgreen
  did -a $1 $2 11 11 2 0 Seagreen
  did -a $1 $2 12 12 2 0 Skyblue
  did -a $1 $2 13 13 2 0 Blue
  did -a $1 $2 14 14 2 0 Pink
  did -a $1 $2 15 15 2 0 Darkgray
  did -a $1 $2 16 16 2 0 Gray
  did -a $1 $2 17 1 No color 
}
;-----------------------------------------------------------------------------------------------------

alias cpanel  dialog -m cpanel cpanel
alias -l cpanel_f return $+(",$scriptdircpanel.txt,")

dialog cpanel {
  title "Control Panel - [/cpanel]"
  size -1 -1 200 120
  option dbu
  list 2, 4 1 192 112, size extsel
}
on *:dialog:cpanel:init:0:{
  var %m = $udll
  dll %m SetMircVersion $version
  dll %m MarkDialog $dname
  dll %m SetControlMDX 2 ListView infotip autoarrange > $vmdx
  did -i $dname 2 1 IconSize normal large
  cpanel.initicon
}
alias  cpanel.initicon {
  var %file = $cpanel_f,%line = 0
  did -r cpanel 2
  did -i cpanel 2 1 clearicons normal
  while (%line < $lines(%file)) {
    inc %line
    tokenize 124 $read(%file,%line)
    var %iconfile = $iif($gettok($2,2,44),$ifmatch,$gettok($1,2,44)) 
    if (!$isfile(%iconfile)) var %iconfile = $imgdir $+ cpanel.ico
    else %iconfile = $2
    did -i cpanel 2 1 SetIcon normal 0 %iconfile
    did -a cpanel 2 0 %line  $1 
  }
}

on *:dialog:cpanel:dclick:*:{
  var %line = $get_a_line($gettok($did(2).seltext,6-,32)) 
  $gettok(%line,3,124)
}
on *:dialog:cpanel:sclick:*:{
  if  ($gettok($did(2,1),1,32) = sclick) {
    var %line = $get_a_line($gettok($did(2).seltext,6-,32)) 
    echo -s Command for Click Icon : $gettok(%line,3,124)
  }
}
alias Get_A_Line {
  var %file = $cpanel_f,%line = 0
  while (%line < $lines(%file)) {
    inc %line
    var %linetext =  $read(%file,%line)
    if ($1- = $gettok(%linetext,1,124))  return %linetext 
  }
}


dialog FriendNotes {
  title "FriendNotes example"
  size -1 -1 214 107
  option dbu
  list 1,3 3 206 88,extsel size
  button "OK", 2, 89 94 36 10, ok
}
on *:dialog:FriendNotes:init:0: {
  mdx SetMircVersion $version 
  mdx MarkDialog $dname
  mdx SetControlMDX $dname 1 Listview  report  Rowselect  grid showsel sortascending droptarget editlabels> $vmdx
  did -i $dname 1 1 headerdims 120 280
  did -i $dname 1 1 headertext $tab(Nicks,Notes)
  friendnotes.init
}
alias  friendnotes.init {
  var %file = $iif($0,$1-,$friendnotes_f)
  if ($read(%file,1) != [friendnotes])  { echo -s Invalid  File Type, %file not a file use for friendNotes | return }
  var %line = 1   , %indexicon, %CurrentIcon = 1
  var %nline = $lines(%file)
  did -r friendnotes 1
  did -i friendnotes 1 1 clearicons normal
  set %defaulticon  $imgdir $+ user.ico
  did -i friendnotes 1 1 SetIcon normal 0 %defaulticon
  while (%line < %nline) {
    inc %line
    tokenize 124 $read(%file,%line)
    if (!$2) %indexicon = 0 
    elseif ($2 = 1) %indexicon = 1
    else  {
      var %iconfile = $iif($gettok($2,2,44),$ifmatch,$gettok($1,2,44)) 
      if (!$isfile(%iconfile)) %indexicon = 1
      else {
        did -i friendnotes 1 1 SetIcon normal  0 $2
        inc %CurrentIcon 
        %indexicon = %currentIcon
      }
    }
    did -a friendnotes 1 1 + %indexicon %indexicon 0  $1 $+ $chr(9) $+ + 0 0 0 $3
    ; did -a friendnotes 1 + %indexicon %indexicon $1 $chr(9) $3
  }
}
alias -l friendnotes_f return $+(",$scriptdirfriendnotes.txt,")
alias -l tab {
  if (!$0) return $chr(9) 
  var %tablist = $1, %i = 2  
  while ( $ [ $+ [ %i ] ] ) { inc %i  | set %tablist $+(%tablist,$chr(9),$ifmatch)  }
  return %tablist
}
alias -l mdx-info {
  if ($0 = 1) {   var %dname = $dname ,  %did = $1  }
  else { var %dname = $1 ,  %did = $2      }
  did -i %dname %did 1 page $prop
  return $gettok($did(%dname, %did, 1), 3-, 32)
}

on *:dialog:FriendNotes:sclick:1: {
  var %action = $gettok($did(1,1),1,32)
  if (( %action == sclick ) || ( %action == item ) || ( %action == stateclick ) || ( %action == rclick )) {
    var %maxsel = $did($dname,1,0).sel
    var %sellist
    var %cursel = 1
    while ( %cursel <= %maxsel ) {
      set %sellist $addtok(%sellist,$did($dname,1,%cursel).sel,44)
      inc %cursel
    }
    echo -s Selection $+ [[ $+ $gettok($did($dname,$did,1),1,32) $+ ]] ( $+ %maxsel $+ ): %sellist
  }
  else if ( %action == drop ) {  friendnotes.init  $mdx-info($dname,$did).dropinfo  | return }
  else if ( %action == beginlabeledit ) echo -s Beginning label edit on ListView item $mdx-info($dname,$did).event
  else if ( %action == endlabeledit ) echo -s Ending label edit on ListView item $mdx-info($dname,$did).event - you typed " $+ $mdx-info($dname,$did).labeledit $+ "
  else if ( %action == cancellabeledit ) echo -s Cancelling label edit on ListView item $mdx-info($dname,$did).event
  else if ( %action == headerclick ) echo -s Clicked ListView header $mdx-info($dname,$did).headerevent
}
on *:DIALOG:friendnotes:dclick:1:{
  var %seltext = $did($dname,$did,$did($dname,$did).sel)
  echo -s Double-click on $did($dname,$did).sel ( $+ $iif($gettok(%seltext,5,32) == 1,un) $+ checked): $gettok($gettok($gettok(%seltext,2-,32),1,9),2-,32)
}
